import * as i0 from '@angular/core';
import { Injectable, Pipe, EventEmitter, Output, Input, Component, NgModule } from '@angular/core';
import * as i1$1 from '@angular/forms';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import * as i2 from '@angular/material/autocomplete';
import { MatAutocompleteModule } from '@angular/material/autocomplete';
import * as i3 from '@angular/material/core';
import * as i4 from '@angular/material/input';
import { MatInputModule } from '@angular/material/input';
import * as i5 from '@angular/material/form-field';
import { MatFormFieldModule } from '@angular/material/form-field';
import * as i6 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i1 from '@angular/platform-browser';
import { MatSelectModule } from '@angular/material/select';

class NgxMatAutocompleteControlService {
    constructor() { }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.13", ngImport: i0, type: NgxMatAutocompleteControlService, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "18.2.13", ngImport: i0, type: NgxMatAutocompleteControlService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.13", ngImport: i0, type: NgxMatAutocompleteControlService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: () => [] });

class HighlightPipe {
    constructor(sanitizer) {
        this.sanitizer = sanitizer;
    }
    transform(text, search, highlightColor) {
        if (search && text) {
            let pattern = search.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g, '\\$&');
            pattern = pattern.split(' ').filter((t) => {
                return t.length > 0;
            }).join('|');
            const regex = new RegExp(pattern, 'gi');
            return this.sanitizer.bypassSecurityTrustHtml(String(text).replace(regex, (match) => `<b style="color:${highlightColor}">${match}</b>`));
        }
        else {
            return text;
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.13", ngImport: i0, type: HighlightPipe, deps: [{ token: i1.DomSanitizer }], target: i0.ɵɵFactoryTarget.Pipe }); }
    static { this.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "18.2.13", ngImport: i0, type: HighlightPipe, name: "highlight" }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.13", ngImport: i0, type: HighlightPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'highlight'
                }]
        }], ctorParameters: () => [{ type: i1.DomSanitizer }] });

class NgxMatAutocompleteControlComponent {
    constructor() {
        this.refId = '';
        this.refName = '';
        this.label = '';
        this.highlightColor = 'black';
        this.appearance = 'outline';
        //|| 'standard' || 'fill' || 'legacy';
        this.options = [];
        this.required = false;
        this.showDefaultSelect = false;
        this.disabled = false;
        this.checkValid = true;
        this.selectionChange = new EventEmitter();
        this.propValueEvent = new EventEmitter();
        this.keyUp = false;
        this.filterList = [];
    }
    ngOnChanges(changes) {
        if (changes) {
            if (+this.control.value > 0) {
                this.tempValue = this.control.value;
                this.setItems('');
                setTimeout(() => {
                    this.control.setValue(this.tempValue);
                }, 0);
            }
        }
        if (changes.disabled && changes.disabled.currentValue) {
            this.control.disable();
        }
        else {
            this.disabled = false;
            this.control.enable();
        }
    }
    ngOnInit() {
        if (this.options) {
            this.setItems('');
        }
    }
    keyUpFunction(event, value) {
        if (event.key === 'Enter' || event.key === 'Tab') {
            event.preventDefault();
            return false;
        }
        else {
            if (value) {
                const data = this.filterList.filter((e) => e[this.refName].toLowerCase() === value.toLowerCase());
                if (data.length > 0) {
                    this.keyUp = true;
                }
                else {
                    this.keyUp = true;
                }
            }
            else {
                this.keyUp = false;
            }
            this.propValueEvent.emit({
                propertyName: this.control,
                value: value
            });
            return true;
        }
    }
    get displayDataFn() {
        const dataNew = (data) => {
            if (data == null || data === undefined || data === '') {
                return null;
            }
            else {
                if (this.filterList && this.filterList.length > 0) {
                    data = this.options.find((x) => x[this.refId] === data);
                    if (data) {
                        return data[this.refName];
                    }
                    else {
                        return null;
                    }
                }
                else {
                    return null;
                }
            }
        };
        return dataNew;
    }
    // Resource ..
    setItems(value) {
        if (!value) {
            this.assignResourceCopy();
        }
        if (value) {
            this.filterList = Object.assign([], this.options).filter((item) => item[this.refName].toLowerCase().indexOf(value.toLowerCase()) > -1);
        }
    }
    assignResourceCopy() {
        this.filterList = Object.assign([], this.options);
    }
    checkValidValue() {
        const value = this.control.value;
        if (value === '' || value == null) {
        }
        else if (this.keyUp) {
            this.control.setErrors({ incorrect: true });
        }
        else {
            this.control.setErrors(null);
        }
    }
    checVal(value) {
        if (this.showDefaultSelect === false && this.options) {
            const data = this.options.filter((e) => e[this.refName].toLowerCase().trim() === value.toLowerCase().trim());
            if (data.length > 0) {
                const datax = data[0];
                this.control.setValue(datax[this.refId]);
                this.keyUp = false;
            }
            this.checkValidValue();
        }
    }
    emitValues(event) {
        this.selectionChange.emit(event.option.value);
        this.propValueEvent.emit({
            propertyName: this.control,
            value: event.option.value
        });
    }
    trackByFn(index, item) {
        return index;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.13", ngImport: i0, type: NgxMatAutocompleteControlComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "18.2.13", type: NgxMatAutocompleteControlComponent, selector: "ngx-mat-autocomplete-control", inputs: { control: "control", refId: "refId", refName: "refName", label: "label", highlightColor: "highlightColor", appearance: "appearance", options: "options", required: "required", showDefaultSelect: "showDefaultSelect", disabled: "disabled", value: "value", checkValid: "checkValid" }, outputs: { selectionChange: "selectionChange", propValueEvent: "propValueEvent" }, usesOnChanges: true, ngImport: i0, template: "<mat-form-field [appearance]=\"appearance\">\r\n  <mat-label>{{ label }}</mat-label>\r\n  <input\r\n    matInput\r\n    [placeholder]=\"label\"\r\n    [matAutocomplete]=\"autoCmpt\"\r\n    #inputVal\r\n    [formControl]=\"control\"\r\n    (focus)=\"setItems(inputVal.value)\"\r\n    (keyup)=\"keyUpFunction($event, inputVal.value)\"\r\n    (input)=\"setItems(inputVal.value)\"\r\n    (blur)=\"checVal(inputVal.value)\"\r\n    (click)=\"inputVal.select()\"\r\n    [required]=\"required\"\r\n  />\r\n  <!-- <img loading=\"lazy\" src=\"assets/images/search.png\" matSuffix width=\"18\" /> -->\r\n  <mat-error *ngIf=\"control?.errors?.required && required\">\r\n    {{ label }} is required\r\n  </mat-error>\r\n  <mat-error *ngIf=\"control?.errors?.incorrect && checkValid\">\r\n    {{ label }} is not valid.\r\n  </mat-error>\r\n\r\n  <mat-autocomplete\r\n    #autoCmpt=\"matAutocomplete\"\r\n    [displayWith]=\"displayDataFn\"\r\n    (optionSelected)=\"emitValues($event)\"\r\n  >\r\n    <!-- <mat-option>-------Select {{label}}-------</mat-option> -->\r\n    <mat-option\r\n      [value]=\"data[refId]\"\r\n      *ngFor=\"let data of filterList; trackBy: trackByFn\"\r\n      class=\"autocom-option autocom-tr\"\r\n    >\r\n      <span [innerHTML]=\"data[refName] | highlight: inputVal.value:highlightColor\"></span>\r\n    </mat-option>\r\n    <mat-option *ngIf=\"filterList.length == 0\">\r\n      <div class=\"no-record\"><span>No Data Found</span></div>\r\n    </mat-option>\r\n  </mat-autocomplete>\r\n</mat-form-field>\r\n", styles: [".no-record{color:#78797b;font-size:14px;font-weight:300;line-height:.5;margin:.5rem 0;padding:30px 20px}.no-record span:before,.no-record span:after{border-bottom:1px solid rgba(0,0,0,.1);border-top:1px solid rgba(0,0,0,.1);content:\"\";height:3px;display:inline-block;width:20px;position:relative;top:-2px}.no-record span:before{margin-right:5px}.no-record span:after{margin-left:5px}.mat-option-text b{color:#000}\n"], dependencies: [{ kind: "directive", type: i1$1.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i1$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i1$1.RequiredValidator, selector: ":not([type=checkbox])[required][formControlName],:not([type=checkbox])[required][formControl],:not([type=checkbox])[required][ngModel]", inputs: ["required"] }, { kind: "directive", type: i1$1.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "component", type: i2.MatAutocomplete, selector: "mat-autocomplete", inputs: ["aria-label", "aria-labelledby", "displayWith", "autoActiveFirstOption", "autoSelectActiveOption", "requireSelection", "panelWidth", "disableRipple", "class", "hideSingleSelectionIndicator"], outputs: ["optionSelected", "opened", "closed", "optionActivated"], exportAs: ["matAutocomplete"] }, { kind: "component", type: i3.MatOption, selector: "mat-option", inputs: ["value", "id", "disabled"], outputs: ["onSelectionChange"], exportAs: ["matOption"] }, { kind: "directive", type: i2.MatAutocompleteTrigger, selector: "input[matAutocomplete], textarea[matAutocomplete]", inputs: ["matAutocomplete", "matAutocompletePosition", "matAutocompleteConnectedTo", "autocomplete", "matAutocompleteDisabled"], exportAs: ["matAutocompleteTrigger"] }, { kind: "directive", type: i4.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly"], exportAs: ["matInput"] }, { kind: "component", type: i5.MatFormField, selector: "mat-form-field", inputs: ["hideRequiredMarker", "color", "floatLabel", "appearance", "subscriptSizing", "hintLabel"], exportAs: ["matFormField"] }, { kind: "directive", type: i5.MatLabel, selector: "mat-label" }, { kind: "directive", type: i5.MatError, selector: "mat-error, [matError]", inputs: ["id"] }, { kind: "directive", type: i6.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i6.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "pipe", type: HighlightPipe, name: "highlight" }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.13", ngImport: i0, type: NgxMatAutocompleteControlComponent, decorators: [{
            type: Component,
            args: [{ selector: 'ngx-mat-autocomplete-control', template: "<mat-form-field [appearance]=\"appearance\">\r\n  <mat-label>{{ label }}</mat-label>\r\n  <input\r\n    matInput\r\n    [placeholder]=\"label\"\r\n    [matAutocomplete]=\"autoCmpt\"\r\n    #inputVal\r\n    [formControl]=\"control\"\r\n    (focus)=\"setItems(inputVal.value)\"\r\n    (keyup)=\"keyUpFunction($event, inputVal.value)\"\r\n    (input)=\"setItems(inputVal.value)\"\r\n    (blur)=\"checVal(inputVal.value)\"\r\n    (click)=\"inputVal.select()\"\r\n    [required]=\"required\"\r\n  />\r\n  <!-- <img loading=\"lazy\" src=\"assets/images/search.png\" matSuffix width=\"18\" /> -->\r\n  <mat-error *ngIf=\"control?.errors?.required && required\">\r\n    {{ label }} is required\r\n  </mat-error>\r\n  <mat-error *ngIf=\"control?.errors?.incorrect && checkValid\">\r\n    {{ label }} is not valid.\r\n  </mat-error>\r\n\r\n  <mat-autocomplete\r\n    #autoCmpt=\"matAutocomplete\"\r\n    [displayWith]=\"displayDataFn\"\r\n    (optionSelected)=\"emitValues($event)\"\r\n  >\r\n    <!-- <mat-option>-------Select {{label}}-------</mat-option> -->\r\n    <mat-option\r\n      [value]=\"data[refId]\"\r\n      *ngFor=\"let data of filterList; trackBy: trackByFn\"\r\n      class=\"autocom-option autocom-tr\"\r\n    >\r\n      <span [innerHTML]=\"data[refName] | highlight: inputVal.value:highlightColor\"></span>\r\n    </mat-option>\r\n    <mat-option *ngIf=\"filterList.length == 0\">\r\n      <div class=\"no-record\"><span>No Data Found</span></div>\r\n    </mat-option>\r\n  </mat-autocomplete>\r\n</mat-form-field>\r\n", styles: [".no-record{color:#78797b;font-size:14px;font-weight:300;line-height:.5;margin:.5rem 0;padding:30px 20px}.no-record span:before,.no-record span:after{border-bottom:1px solid rgba(0,0,0,.1);border-top:1px solid rgba(0,0,0,.1);content:\"\";height:3px;display:inline-block;width:20px;position:relative;top:-2px}.no-record span:before{margin-right:5px}.no-record span:after{margin-left:5px}.mat-option-text b{color:#000}\n"] }]
        }], ctorParameters: () => [], propDecorators: { control: [{
                type: Input
            }], refId: [{
                type: Input
            }], refName: [{
                type: Input
            }], label: [{
                type: Input
            }], highlightColor: [{
                type: Input
            }], appearance: [{
                type: Input
            }], options: [{
                type: Input
            }], required: [{
                type: Input
            }], showDefaultSelect: [{
                type: Input
            }], disabled: [{
                type: Input
            }], value: [{
                type: Input
            }], checkValid: [{
                type: Input
            }], selectionChange: [{
                type: Output
            }], propValueEvent: [{
                type: Output
            }] } });

class AutocompleteControlPipe {
    transform(value, mainForm, subForm, formArrIndex) {
        if (formArrIndex != -1) {
            const formArr = mainForm.controls[subForm];
            return formArr.controls[formArrIndex].controls[value];
        }
        else if (subForm !== '') {
            const formArr = mainForm.controls[subForm];
            return formArr.controls[value];
        }
        else {
            return mainForm?.controls[value];
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.13", ngImport: i0, type: AutocompleteControlPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe }); }
    static { this.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "18.2.13", ngImport: i0, type: AutocompleteControlPipe, name: "autocompleteControl" }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.13", ngImport: i0, type: AutocompleteControlPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'autocompleteControl'
                }]
        }] });

class NgxMatAutocompleteControlModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.13", ngImport: i0, type: NgxMatAutocompleteControlModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "18.2.13", ngImport: i0, type: NgxMatAutocompleteControlModule, declarations: [NgxMatAutocompleteControlComponent, HighlightPipe, AutocompleteControlPipe], imports: [FormsModule,
            ReactiveFormsModule,
            MatAutocompleteModule,
            MatInputModule,
            MatSelectModule,
            MatFormFieldModule,
            CommonModule], exports: [NgxMatAutocompleteControlComponent,
            FormsModule,
            ReactiveFormsModule,
            MatAutocompleteModule,
            MatInputModule,
            MatSelectModule,
            MatFormFieldModule] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "18.2.13", ngImport: i0, type: NgxMatAutocompleteControlModule, imports: [FormsModule,
            ReactiveFormsModule,
            MatAutocompleteModule,
            MatInputModule,
            MatSelectModule,
            MatFormFieldModule,
            CommonModule, FormsModule,
            ReactiveFormsModule,
            MatAutocompleteModule,
            MatInputModule,
            MatSelectModule,
            MatFormFieldModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.13", ngImport: i0, type: NgxMatAutocompleteControlModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NgxMatAutocompleteControlComponent, HighlightPipe, AutocompleteControlPipe],
                    imports: [
                        FormsModule,
                        ReactiveFormsModule,
                        MatAutocompleteModule,
                        MatInputModule,
                        MatSelectModule,
                        MatFormFieldModule,
                        CommonModule
                    ],
                    exports: [NgxMatAutocompleteControlComponent,
                        FormsModule,
                        ReactiveFormsModule,
                        MatAutocompleteModule,
                        MatInputModule,
                        MatSelectModule,
                        MatFormFieldModule]
                }]
        }] });

/*
 * Public API Surface of ngx-mat-autocomplete-control
 */

/**
 * Generated bundle index. Do not edit.
 */

export { NgxMatAutocompleteControlComponent, NgxMatAutocompleteControlModule, NgxMatAutocompleteControlService };
//# sourceMappingURL=ngx-mat-autocomplete-control.mjs.map
